#include "alternating_adaptivemeans_means2gmm_then_lloydsforgmm_id.h"

#include "../../../base/base.h"
#include "../../../algorithm/initutil.h"

AlternatingAdaptiveMeans2GMMThenLloydsForGMMID::AlternatingAdaptiveMeans2GMMThenLloydsForGMMID(fp_type factor, bool spherical, unsigned int substeps, bool sphericalLloyds, uint32_t s) 
	: seed(s), factor(factor), substeps(substeps), spherical(spherical), sphericalLloyds(sphericalLloyds)
{
	std::stringstream sstream;
	sstream << "Alt_AdaptMean+Means2GMM_";
	if(sphericalLloyds)
		sstream << "Sph";
	sstream << "LloydsForGMM";
	if(spherical)
		sstream << "_spherical";
	sstream << "_f" << factor << "_s" << substeps << "_i" << s ;
	this->nametag = sstream.str();
}

GMMDesc AlternatingAdaptiveMeans2GMMThenLloydsForGMMID::compute(commonutil::DataSet const& input, unsigned int k)
{
	std::mt19937 gen(seed);
	return initutil::alternatingAdaptiveMeanAndMeanToGMMThenLloydsForGMM(input, k, gen, factor, spherical, substeps, sphericalLloyds);
}
