#include "gonzalezforgmm_then_lloydsforgmm_id.h"

#include "../../../base/base.h"
#include "../../../algorithm/initutil.h"

GonzalezForGMMThenLloydsForGMMID::GonzalezForGMMThenLloydsForGMMID(bool use2GMM, bool spherical, fp_type sampleFactor,unsigned int substeps, bool sphericalLloyds, uint32_t s) 
	: seed(s), use2GMM(use2GMM), spherical(spherical), sampleFactor(sampleFactor), substeps(substeps), sphericalLloyds(sphericalLloyds)
{
	std::stringstream sstream;
	sstream << "GonzalezForGMM_";
	if(sphericalLloyds)
		sstream << "Sph";
	sstream << "LloydsForGMM";
	if(spherical)
		sstream << "_spherical";
	sstream << "_2mm" << use2GMM << "_f" << sampleFactor << "_s" << substeps << "_i" << s ;
	this->nametag = sstream.str();
}

GMMDesc GonzalezForGMMThenLloydsForGMMID::compute(commonutil::DataSet const& input, unsigned int k)
{
	std::mt19937 gen(seed);
	return initutil::gonzalezForGMMThenLloydsForGMM(input, k, gen, use2GMM, spherical, sampleFactor, substeps, sphericalLloyds);
}
